using System;
using System.Data;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using ProductList;
using System.Diagnostics;

public partial class Insert_batch : System.Web.UI.Page
{
    protected void btnAddRowsToTable_Click(object sender, EventArgs e)
    {
        // Declare variables used for looping and to set the ID for textboxes (NumberOfRows)
        Int32 StartNumber = default(Int32);
        Int32 EndNumber = Convert.ToInt32(txtAddRows.Text);
        Int32 NumberOfRows = ManyRowsTable.Rows.Count - 1;

        // Declare variables for a table row, a table cell and a textbox
        TableRow tRow = default(TableRow);
        TableCell tCell = default(TableCell);
        TextBox tTextBox = default(TextBox);

        // A For-loop to add rows to our ASP.NET table

        for (StartNumber = 1; StartNumber <= EndNumber; StartNumber++)
        {
            // Add the first table row
            tRow = new TableRow();
            ManyRowsTable.Rows.Add(tRow);

            // Add the first table cell
            tCell = new TableCell();
            tRow.Cells.Add(tCell);

            // Add the first textbox
            tTextBox = new TextBox();
            tTextBox.ID = "txtLinkName" + (NumberOfRows + StartNumber);
            tTextBox.Width = Unit.Percentage(95);
            tCell.Controls.Add(tTextBox);

            // Add the second table cell
            tCell = new TableCell();
            tRow.Cells.Add(tCell);

            // Add the second textbox
            tTextBox = new TextBox();
            tTextBox.ID = "txtDescription" + (NumberOfRows + StartNumber);
            tTextBox.Width = Unit.Percentage(95);
            tCell.Controls.Add(tTextBox);
        }

        // Add the number of added rows to a session variable so that we are able to retain the added rows 
        // and the values (ViewState) in added textboxes, see the Page_Init event.
        Session["AddedRows"] = EndNumber + Convert.ToInt32(Session["AddedRows"]);
    }

    protected void Page_Init(object sender, System.EventArgs e)
    {

        // Declare variables used for looping and to set the ID for textboxes (NumberOfRows)
        Int32 StartNumber = default(Int32);
        Int32 AddedRows = 0;
        Int32 NumberOfRows = ManyRowsTable.Rows.Count - 1;

        // Set the number of added rows.
        if (Session["AddedRows"] != null)
        {
            AddedRows = Convert.ToInt32(Session["AddedRows"]);
        }

        // Declare variables for a table row, a table cell and a textbox
        TableRow tRow = default(TableRow);
        TableCell tCell = default(TableCell);
        TextBox tTextBox = default(TextBox);

        // A For-loop to add rows to our ASP.NET table
        for (StartNumber = 1; StartNumber <= AddedRows; StartNumber++)
        {
            // Add the first table row
            tRow = new TableRow();
            ManyRowsTable.Rows.Add(tRow);

            // Add the first table cell
            tCell = new TableCell();
            tRow.Cells.Add(tCell);

            // Add the first textbox
            tTextBox = new TextBox();
            tTextBox.ID = "txtLinkName" + (NumberOfRows + StartNumber);
            tTextBox.Width = Unit.Percentage(95);
            tCell.Controls.Add(tTextBox);

            // Add the second table cell
            tCell = new TableCell();
            tRow.Cells.Add(tCell);

            // Add the second textbox
            tTextBox = new TextBox();
            tTextBox.ID = "txtDescription" + (NumberOfRows + StartNumber);
            tTextBox.Width = Unit.Percentage(95);
            tCell.Controls.Add(tTextBox);
        }
    }

    protected void btnInsertSqlDataAdapter_Click(object sender, EventArgs e)
    {
        // Create a new instance of the Stopwatch class and declare a variable to store the elapsed time.
        Stopwatch Timer = new Stopwatch();
        TimeSpan time = default(TimeSpan);

        // The using block is used to automatically call dispose for the DataTable when it is not used any more
        using (DataTable ManyRowsDataTable = new DataTable())
        {

            // Declare variables for DataColumn and DataRow objects.
            DataColumn column = null;
            DataRow row = null;

            // Create and add the first column
            column = new DataColumn("LinkName");
            ManyRowsDataTable.Columns.Add(column);

            // Create and add the second column
            column = new DataColumn("Description");
            ManyRowsDataTable.Columns.Add(column);

            // Declare variables for a tablerow, rownumber and total number of table rows (ignoring the TableHeaderRow) 
            Int32 CurrentRow = default(Int32);
            Int32 RowNumber = 1;
            Int32 TotalOfTableRows = ManyRowsTable.Rows.Count - 1;

            // A For-loop to loop through each table row in our ASP.NET table and to add rows in our ManyRowsDataTable

            for (CurrentRow = 1; CurrentRow <= TotalOfTableRows; CurrentRow++)
            {
                // Find the textboxes in each table row
                TextBox LinkNameText = (TextBox)ManyRowsTable.FindControl("txtLinkName" + RowNumber);
                TextBox DescriptionText = (TextBox)ManyRowsTable.FindControl("txtDescription" + RowNumber);

                // Add a row in the ManyRowsDataTable if the values in both of the textboxes not is blank
                if (!(LinkNameText.Text == string.Empty) & !(DescriptionText.Text == string.Empty))
                {
                    // Add one row with values in the two columns LinkName and Description
                    row = ManyRowsDataTable.NewRow();
                    row["LinkName"] = LinkNameText.Text;
                    row["Description"] = DescriptionText.Text;
                    ManyRowsDataTable.Rows.Add(row);

                    // Add 1 to the rownumber
                    RowNumber = RowNumber + 1;

                }

            }

            // Start the stopwatch
            Timer.Start();

            // Declare InsertManyRows as a new instance of the HeadCategories class
            HeadCategories InsertManyRows = new HeadCategories();

            // Call the method InsertManyRows in the HeadCategories class and add the DataTable as a parameter
            InsertManyRows.InsertManyRows(ManyRowsDataTable);

            //Stop the stopwatch
            Timer.Stop();

            // Get the elapsed time between start and stop
            time = Timer.Elapsed;

        }

        // Delete the session that stores the number of added rows
        Session.Remove("AddedRows");

        // Print the elapsed time to the "lblInsertTime" label
        lblInsertTime.Text = "The SQL insert took: " + string.Format("{0:00}:{1:00}:{2:00}.{3:00}", time.Hours, time.Minutes, time.Seconds, time.Milliseconds / 10);

    }

    protected void btnInsertSqlBulkCopy_Click(object sender, EventArgs e)
    {
        // Create a new instance of the Stopwatch class and declare a variable to store the elapsed time.
        Stopwatch Timer = new Stopwatch();
        TimeSpan time = default(TimeSpan);

        // The Using block is used to automatically call dispose for the DataTable when it is not used any more
        using (DataTable ManyRowsDataTable = new DataTable())
        {

            // Declare variables for DataColumn and DataRow objects.
            DataColumn column = null;
            DataRow row = null;

            // Create and add the first column
            column = new DataColumn("LinkName");
            ManyRowsDataTable.Columns.Add(column);

            // Create and add the second column
            column = new DataColumn("Description");
            ManyRowsDataTable.Columns.Add(column);

            // Declare variables for a tablerow, rownumber and total number of table rows (ignoring the TableHeaderRow) 
            Int32 CurrentRow = default(Int32);
            Int32 RowNumber = 1;
            Int32 TotalOfTableRows = ManyRowsTable.Rows.Count - 1;

            // A For-loop to loop through each table row in our ASP.NET table and to add rows in our ManyRowsDataTable

            for (CurrentRow = 1; CurrentRow <= TotalOfTableRows; CurrentRow++)
            {
                // Find the textboxes in each table row
                TextBox LinkNameText = (TextBox)ManyRowsTable.FindControl("txtLinkName" + RowNumber);
                TextBox DescriptionText = (TextBox)ManyRowsTable.FindControl("txtDescription" + RowNumber);

                // Add a row in the ManyRowsDataTable if the values in both of the textboxes not is blank
                if (!(LinkNameText.Text == string.Empty) & !(DescriptionText.Text == string.Empty))
                {
                    // Add one row with values in the two columns LinkName and Description
                    row = ManyRowsDataTable.NewRow();
                    row["LinkName"] = LinkNameText.Text;
                    row["Description"] = DescriptionText.Text;
                    ManyRowsDataTable.Rows.Add(row);

                    // Add 1 to the rownumber
                    RowNumber = RowNumber + 1;

                }

            }

            // Start the stopwatch
            Timer.Start();

            // Declare InsertBulk as a new instance of the HeadCategories class
            HeadCategories InsertBulk = new HeadCategories();

            // Call the method InsertSqlBulk in the HeadCategories class and add the DataTable as a parameter
            InsertBulk.InsertSqlBulk(ManyRowsDataTable);

            //Stop the stopwatch
            Timer.Stop();

            // Get the elapsed time between start and stop
            time = Timer.Elapsed;

        }

        // Delete the session that stores the number of added rows
        Session.Remove("AddedRows");

        // Print the elapsed time to the "lblInsertTime" label
        lblInsertTime.Text = "The SQL insert took: " + string.Format("{0:00}:{1:00}:{2:00}.{3:00}", time.Hours, time.Minutes, time.Seconds, time.Milliseconds / 10);

    }
}
